import React from 'react';
import QueryStore, { QueryStoreItem } from '../utility/QueryStore';
import { HandleEditLabelFn, HandleToggleFavoriteFn, HandleSelectQueryFn } from './HistoryQuery';
import StorageAPI from '../utility/StorageAPI';
import { WithTranslation } from 'react-i18next';
declare type QueryHistoryProps = {
    query?: string;
    variables?: string;
    headers?: string;
    operationName?: string;
    queryID?: number;
    onSelectQuery: HandleSelectQueryFn;
    storage: StorageAPI;
} & WithTranslation;
declare type QueryHistoryState = {
    queries: Array<QueryStoreItem>;
};
export declare class QueryHistorySource extends React.Component<QueryHistoryProps, QueryHistoryState> {
    historyStore: QueryStore;
    favoriteStore: QueryStore;
    constructor(props: QueryHistoryProps);
    render(): JSX.Element;
    updateHistory: (query?: string | undefined, variables?: string | undefined, headers?: string | undefined, operationName?: string | undefined) => void;
    toggleFavorite: HandleToggleFavoriteFn;
    editLabel: HandleEditLabelFn;
}
export declare const QueryHistory: React.ComponentType<Pick<QueryHistoryProps, "variables" | "query" | "operationName" | "headers" | "queryID" | "onSelectQuery" | "storage"> & import("react-i18next").WithTranslationProps>;
export {};
//# sourceMappingURL=QueryHistory.d.ts.map