var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx } from 'theme-ui';
import { useCallback, useEffect, useRef, useState } from 'react';
export var ResizeHandler = function (props) {
    var dir = props.dir, onStart = props.onStart, onEnd = props.onEnd, onUpdate = props.onUpdate, className = props.className, style = props.style, children = props.children;
    var _a = useState(false), isDragging = _a[0], setIsDragging = _a[1];
    var listenersRef = useRef(null);
    var handleMouseMove = useCallback(function (e) {
        onUpdate(e);
    }, [onUpdate]);
    var cleanMouseListeners = useCallback(function () {
        var oldRef = listenersRef.current;
        if (oldRef) {
            window.removeEventListener('mousemove', oldRef.handleMouseMove);
            window.removeEventListener('touchmove', oldRef.handleMouseMove);
            window.removeEventListener('mouseup', oldRef.handleMouseUp);
            window.removeEventListener('touchend', oldRef.handleMouseUp);
        }
    }, []);
    var handleMouseUp = useCallback(function (e) {
        setIsDragging(false);
        cleanMouseListeners();
        onEnd(e);
    }, [cleanMouseListeners, onEnd]);
    var handleMouseDown = useCallback(function (e) {
        setIsDragging(true);
        cleanMouseListeners();
        listenersRef.current = {
            handleMouseMove: handleMouseMove,
            handleMouseUp: handleMouseUp,
        };
        window.addEventListener('mousemove', handleMouseMove);
        window.addEventListener('touchmove', handleMouseMove);
        window.addEventListener('mouseup', handleMouseUp);
        window.addEventListener('touchend', handleMouseUp);
        onStart(e);
    }, [cleanMouseListeners, handleMouseMove, handleMouseUp, onStart]);
    useEffect(function () {
        return function () {
            cleanMouseListeners();
        };
    }, []);
    return (jsx("div", { onMouseDown: handleMouseDown, onTouchStart: handleMouseDown, className: className, style: __assign({ cursor: dir + "-resize" }, style) },
        isDragging && (jsx("style", null, "\n        * {\n          cursor: " + dir + "-resize !important;\n          -webkit-user-select: none !important;\n        }\n        ")),
        children));
};
//# sourceMappingURL=ResizeHandler.js.map