var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useRef, useState } from 'react';
import { ResizeHandler } from './ResizeHandler';
import { getContainerInfo, getContainerMeta, getHandlerInfo, isNil, normalizeMEvent, } from './util';
export var Resizer = function (props) {
    var border = props.border, onStart = props.onStart, onEnd = props.onEnd, onUpdate = props.onUpdate, id = props.id, className = props.className, style = props.style, handlerClassName = props.handlerClassName, _handlerStyle = props.handlerStyle, _handlerWidth = props.handlerWidth, _handlerOffset = props.handlerOffset, _handlerZIndex = props.handlerZIndex, children = props.children;
    var handlerWidth = isNil(_handlerWidth) ? 16 : _handlerWidth;
    var handlerOffset = (isNil(_handlerOffset)
        ? -handlerWidth / 2
        : _handlerOffset);
    var handlerZIndex = (isNil(_handlerZIndex) ? 10 : _handlerZIndex);
    var _a = useState(0), diffCoord = _a[0], setDiffCoord = _a[1];
    var _b = useState(null), oldSize = _b[0], setOldSize = _b[1];
    var oldCoordRef = useRef(null);
    var boxRef = useRef(null);
    var containerMeta = getContainerMeta({ border: border });
    var containerStyle = getContainerInfo({
        style: style,
        containerMeta: containerMeta,
        diffCoord: diffCoord,
        oldSize: oldSize,
    }).style;
    var _c = getHandlerInfo({
        border: border,
        handlerWidth: handlerWidth,
        handlerOffset: handlerOffset,
        handlerStyle: _handlerStyle,
    }), dir = _c.dir, handlerStyle = _c.style;
    var handleStart = useCallback(function (_e) {
        var e = normalizeMEvent(_e);
        var wh = containerMeta.wh, xy = containerMeta.xy;
        var el = boxRef.current;
        if (!el) {
            return;
        }
        var px = window.getComputedStyle(el)[wh];
        setDiffCoord(0);
        setOldSize(parseInt(px, 10));
        oldCoordRef.current = e[xy];
        if (onStart) {
            onStart(e);
        }
    }, [containerMeta, onStart]);
    var handleEnd = useCallback(function (_e) {
        var e = normalizeMEvent(_e);
        if (onEnd) {
            onEnd(e);
        }
    }, [onEnd]);
    var handleUpdate = useCallback(function (_e) {
        var e = normalizeMEvent(_e);
        var xy = containerMeta.xy;
        if (oldCoordRef.current === null) {
            return;
        }
        setDiffCoord(e[xy] - oldCoordRef.current);
        if (onUpdate) {
            onUpdate(e);
        }
    }, [containerMeta, onUpdate]);
    return (React.createElement("div", { ref: boxRef, id: id, className: className, style: __assign({ position: 'relative' }, containerStyle) },
        React.createElement(ResizeHandler, { dir: dir, className: handlerClassName, style: __assign({ position: 'absolute', zIndex: handlerZIndex }, handlerStyle), onStart: handleStart, onEnd: handleEnd, onUpdate: handleUpdate }),
        children));
};
//# sourceMappingURL=Resizer.js.map